diff --git a/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-char.c b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-char.c
new file mode 100644
index 0000000..1fc5f16
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-char.c
@@ -0,0 +1,38 @@
+/* Verify that overloaded built-ins for __builtin_vec_xl with char
+   inputs produce the right code.  */
+
+/* { dg-do compile { target { powerpc*-*-linux*  } } } */
+/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-mvsx -O2" } */
+
+#include <altivec.h>
+
+#define BUILD_VAR_TEST(TESTNAME1, RETTYPE, VAR_OFFSET, LOADFROM)\
+RETTYPE								\
+TESTNAME1 ## _var (VAR_OFFSET offset, LOADFROM * loadfrom) 		\
+{								\
+	return __builtin_vec_xl (offset, loadfrom);		\
+}
+
+#define BUILD_CST_TEST(TESTNAME1, RETTYPE, CST_OFFSET, LOADFROM)	\
+RETTYPE								\
+TESTNAME1 ## _cst (LOADFROM * loadfrom) 				\
+{								\
+	return __builtin_vec_xl (CST_OFFSET, loadfrom);		\
+}
+
+BUILD_VAR_TEST( test1, vector signed char,   signed long long, signed char);
+BUILD_VAR_TEST( test2, vector signed char,   signed int, signed char);
+BUILD_CST_TEST( test3, vector signed char,   2, signed char);
+BUILD_VAR_TEST( test4, vector unsigned char, signed long long, unsigned char);
+BUILD_VAR_TEST( test5 ,vector unsigned char, signed int, unsigned char);
+BUILD_CST_TEST( test6, vector unsigned char, 4, unsigned char);
+
+BUILD_VAR_TEST( test7, vector signed char,   signed long long, vector signed char);
+BUILD_VAR_TEST( test8, vector signed char,   signed int, vector signed char);
+BUILD_CST_TEST( test9, vector signed char,   6, vector signed char);
+BUILD_VAR_TEST( test10, vector unsigned char, signed long long, vector unsigned char);
+BUILD_VAR_TEST( test11, vector unsigned char, signed int, vector unsigned char);
+BUILD_CST_TEST( test12, vector unsigned char, 8, vector unsigned char);
+
+/* { dg-final { scan-assembler-times "lxvw4x|lxvd2x|lxvx|lvx" 12 } } */
diff --git a/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-double.c b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-double.c
new file mode 100644
index 0000000..7fbc65d
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-double.c
@@ -0,0 +1,32 @@
+/* Verify that overloaded built-ins for __builtin_vec_xl with double
+   inputs produce the right code.  */
+
+/* { dg-do compile { target { powerpc*-*-linux*  } } } */
+/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-mvsx -O2" } */
+
+#include <altivec.h>
+
+#define BUILD_VAR_TEST(TESTNAME1, RETTYPE, VAR_OFFSET, LOADFROM)\
+RETTYPE								\
+TESTNAME1 ## _var (VAR_OFFSET offset, LOADFROM * loadfrom) 		\
+{								\
+	return __builtin_vec_xl (offset, loadfrom);		\
+}
+
+#define BUILD_CST_TEST(TESTNAME1, RETTYPE, CST_OFFSET, LOADFROM)	\
+RETTYPE								\
+TESTNAME1 ## _cst (LOADFROM * loadfrom) 				\
+{								\
+	return __builtin_vec_xl (CST_OFFSET, loadfrom);		\
+}
+
+BUILD_VAR_TEST( test1, vector double, signed long long, double);
+BUILD_VAR_TEST( test2, vector double, signed int, double);
+BUILD_CST_TEST( test3, vector double, 12, double);
+
+BUILD_VAR_TEST( test4, vector double, signed long long, vector double);
+BUILD_VAR_TEST( test5, vector double, signed int, vector double);
+BUILD_CST_TEST( test6, vector double, 12, vector double);
+
+/* { dg-final { scan-assembler-times "lxvd2x|lxvx|lvx" 6 } } */
diff --git a/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-float.c b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-float.c
new file mode 100644
index 0000000..0743b0e
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-float.c
@@ -0,0 +1,32 @@
+/* Verify that overloaded built-ins for __builtin_vec_xl with float
+   inputs produce the right code.  */
+
+/* { dg-do compile { target { powerpc*-*-linux*  } } } */
+/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-mvsx -O2" } */
+
+#include <altivec.h>
+
+#define BUILD_VAR_TEST(TESTNAME1, RETTYPE, VAR_OFFSET, LOADFROM)\
+RETTYPE								\
+TESTNAME1 ## _var (VAR_OFFSET offset, LOADFROM * loadfrom) 		\
+{								\
+	return __builtin_vec_xl (offset, loadfrom);		\
+}
+
+#define BUILD_CST_TEST(TESTNAME1, RETTYPE, CST_OFFSET, LOADFROM)	\
+RETTYPE								\
+TESTNAME1 ## _cst (LOADFROM * loadfrom) 				\
+{								\
+	return __builtin_vec_xl (CST_OFFSET, loadfrom);		\
+}
+
+BUILD_VAR_TEST( test1, vector float, signed long long, float);
+BUILD_VAR_TEST( test2, vector float, signed int, float);
+BUILD_CST_TEST( test3, vector float, 12, float);
+
+BUILD_VAR_TEST( test4, vector float, signed long long, vector float);
+BUILD_VAR_TEST( test5, vector float, signed int, vector float);
+BUILD_CST_TEST( test6, vector float, 12, vector float);
+
+/* { dg-final { scan-assembler-times "lxvw4x|lxvd2x|lxvx|lvx" 6 } } */
diff --git a/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-int.c b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-int.c
new file mode 100644
index 0000000..5e868f4
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-int.c
@@ -0,0 +1,40 @@
+/* Verify that overloaded built-ins for __builtin_vec_xl with int
+   inputs produce the right code.  */
+
+/* { dg-do compile { target { powerpc*-*-linux*  } } } */
+/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-mvsx -O2" } */
+
+#include <altivec.h>
+
+#define BUILD_VAR_TEST(TESTNAME1, RETTYPE, VAR_OFFSET, LOADFROM)\
+RETTYPE								\
+TESTNAME1 ## _var (VAR_OFFSET offset, LOADFROM * loadfrom) 		\
+{								\
+	return __builtin_vec_xl (offset, loadfrom);		\
+}
+
+#define BUILD_CST_TEST(TESTNAME1, RETTYPE, CST_OFFSET, LOADFROM)	\
+RETTYPE								\
+TESTNAME1 ## _cst (LOADFROM * loadfrom) 				\
+{								\
+	return __builtin_vec_xl (CST_OFFSET, loadfrom);		\
+}
+
+BUILD_VAR_TEST( test1, vector signed int, signed long long, signed int);
+BUILD_VAR_TEST( test2, vector signed int, signed int, signed int);
+BUILD_CST_TEST( test3, vector signed int, 12, signed int);
+
+BUILD_VAR_TEST( test4, vector unsigned int, signed long long, unsigned int);
+BUILD_VAR_TEST( test5, vector unsigned int, signed int, unsigned int);
+BUILD_CST_TEST( test6, vector unsigned int, 12, unsigned int);
+
+BUILD_VAR_TEST( test7, vector signed int, signed long long, vector signed int);
+BUILD_VAR_TEST( test8, vector signed int, signed int, vector signed int);
+BUILD_CST_TEST( test9, vector signed int, 12, vector signed int);
+
+BUILD_VAR_TEST( test10, vector unsigned int, signed long long, vector unsigned int);
+BUILD_VAR_TEST( test11, vector unsigned int, signed int, vector unsigned int);
+BUILD_CST_TEST( test12, vector unsigned int, 12, vector unsigned int);
+
+/* { dg-final { scan-assembler-times "lxvw4x|lxvd2x|lxvx|lvx" 12 } } */
diff --git a/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-longlong.c b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-longlong.c
new file mode 100644
index 0000000..3f08de4
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-longlong.c
@@ -0,0 +1,40 @@
+/* Verify that overloaded built-ins for __builtin_vec_xl with long long
+   inputs produce the right code.  */
+
+/* { dg-do compile { target { powerpc*-*-linux*  } } } */
+/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-mvsx -O2" } */
+
+#include <altivec.h>
+
+#define BUILD_VAR_TEST(TESTNAME1, RETTYPE, VAR_OFFSET, LOADFROM)\
+RETTYPE								\
+TESTNAME1 ## _var (VAR_OFFSET offset, LOADFROM * loadfrom) 		\
+{								\
+	return __builtin_vec_xl (offset, loadfrom);		\
+}
+
+#define BUILD_CST_TEST(TESTNAME1, RETTYPE, CST_OFFSET, LOADFROM)	\
+RETTYPE								\
+TESTNAME1 ## _cst (LOADFROM * loadfrom) 				\
+{								\
+	return __builtin_vec_xl (CST_OFFSET, loadfrom);		\
+}
+
+BUILD_VAR_TEST( test1,  vector signed long long, signed long long, signed long long);
+BUILD_VAR_TEST( test2,  vector signed long long, signed int, signed long long);
+BUILD_CST_TEST( test3,  vector signed long long, 12, signed long long);
+
+BUILD_VAR_TEST( test4,  vector unsigned long long, signed long long, unsigned long long);
+BUILD_VAR_TEST( test5,  vector unsigned long long, signed int, unsigned long long);
+BUILD_CST_TEST( test6,  vector unsigned long long, 12, unsigned long long);
+
+BUILD_VAR_TEST( test7,  vector signed long long, signed long long, vector signed long long);
+BUILD_VAR_TEST( test8,  vector signed long long, signed int, vector signed long long);
+BUILD_CST_TEST( test9,  vector signed long long, 12, vector signed long long);
+
+BUILD_VAR_TEST( test10,  vector unsigned long long, signed long long, vector unsigned long long);
+BUILD_VAR_TEST( test11,  vector unsigned long long, signed int, vector unsigned long long);
+BUILD_CST_TEST( test12,  vector unsigned long long, 12, vector unsigned long long);
+
+/* { dg-final { scan-assembler-times "lxvd2x|lxvx|lvx" 12 } } */
diff --git a/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-short.c b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-short.c
new file mode 100644
index 0000000..231a151
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/fold-vec-load-builtin_vec_xl-short.c
@@ -0,0 +1,40 @@
+/* Verify that overloaded built-ins for __builtin_vec_xl with short
+   inputs produce the right code.  */
+
+/* { dg-do compile { target { powerpc*-*-linux*  } } } */
+/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-mvsx -O2" } */
+
+#include <altivec.h>
+
+#define BUILD_VAR_TEST(TESTNAME1, RETTYPE, VAR_OFFSET, LOADFROM)\
+RETTYPE								\
+TESTNAME1 ## _var (VAR_OFFSET offset, LOADFROM * loadfrom) 		\
+{								\
+	return __builtin_vec_xl (offset, loadfrom);		\
+}
+
+#define BUILD_CST_TEST(TESTNAME1, RETTYPE, CST_OFFSET, LOADFROM)	\
+RETTYPE								\
+TESTNAME1 ## _cst (LOADFROM * loadfrom) 				\
+{								\
+	return __builtin_vec_xl (CST_OFFSET, loadfrom);		\
+}
+
+BUILD_VAR_TEST( test1,  vector signed short, signed long long, signed short);
+BUILD_VAR_TEST( test2,  vector signed short, signed int, signed short);
+BUILD_CST_TEST( test3,  vector signed short, 12, signed short);
+
+BUILD_VAR_TEST( test4,  vector unsigned short, signed long long, unsigned short);
+BUILD_VAR_TEST( test5,  vector unsigned short, signed int, unsigned short);
+BUILD_CST_TEST( test6,  vector unsigned short, 12, unsigned short);
+
+BUILD_VAR_TEST( test7,  vector signed short, signed long long, vector signed short);
+BUILD_VAR_TEST( test8,  vector signed short, signed int, vector signed short);
+BUILD_CST_TEST( test9,  vector signed short, 12, vector signed short);
+
+BUILD_VAR_TEST( test10,  vector unsigned short, signed long long, vector unsigned short);
+BUILD_VAR_TEST( test11,  vector unsigned short, signed int, vector unsigned short);
+BUILD_CST_TEST( test12,  vector unsigned short, 12, vector unsigned short);
+
+/* { dg-final { scan-assembler-times "lxvw4x|lxvd2x|lxvx|lvx" 12 } } */